/*
* V:2.0 
* Anbindung einer I2C-Eingabe und einer I2C-Ausgabe-Karte (http://www.horter.de/i2c/index.htm)
* Anbindung des Raspberry PI ber Modbus mittels modbus.h und wiringPI.h und I2C
* Auslesen 1-Wire DS18B20 ber Module "w1-gpio" "w1-therm" und deren Verzeichnis
*/
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <modbus/modbus.h>
#include <wiringPi.h>
#include <wiringPiI2C.h>
#include <string.h>
#include <time.h>

modbus_t *ctx;
modbus_mapping_t *mb_mapping;
int i,j,socket,fd,fd2,temp,e,n;
int dID = 0x27;						//Hex-Adresse I2C-Ausgabekarte ermittelt ber "i2cdetect -y 1"
int dID2 = 0x3d;					//Hex-Adresse I2C-Eingabekarte ermittelt ber "i2cdetect -y 1"
char tempsensor[20];
int i2c_out_1[8][2]={{0},{0}};		//I2C-Bus zweidimensionales Array fr Ausgang (fr interne Rechnungen)
int i2c_in_1[8][2]={{0},{0}};		//I2C-Bus zweidimensionales Array fr Eingang (fr interne Rechnungen)


int gpio[] = {7,0,1,2,3,4,5,6,10,11,12,13,14,15,16,17};	//16-IO Adressen 8und9 I2C
//Umrechnung Bit in GPIO-Port unter "https://projects.drogon.net/raspberry-pi/wiringpi/pins/"

FILE *ptr_file;
char buf[100];
char *p;
double tempx;
	
/*
typedef struct {
  int nb_bits;
  int nb_input_bits;
  int nb_input_registers;
  int nb_registers;
  uint8_t *tab_bits;
  uint8_t *tab_input_bits;
  uint16_t *tab_input_registers;
  uint16_t *tab_registers;
} modbus_mapping_t;
*/

int mb_init(void)
{
  printf ("modbus init\n") ;
  ctx = modbus_new_tcp("0.0.0.0", 1502);
  /* modbus_set_debug(ctx, TRUE); */
  mb_mapping = modbus_mapping_new(32, 48, 0, 65);		//war 8,18,0,32	//letztes Byte 65 wenn Temp auf 64
  /*  Aufbau:											//24 Outputs (0-23) und 16 Inputs (24-39) 
      mb_mapping = modbus_mapping_new(					//I2C: (16-23: Output) (32-39: Input) 
        UT_BITS_ADDRESS + UT_BITS_NB,
        UT_INPUT_BITS_ADDRESS + UT_INPUT_BITS_NB,
        UT_REGISTERS_ADDRESS + UT_REGISTERS_NB,
        UT_INPUT_REGISTERS_ADDRESS + UT_INPUT_REGISTERS_NB);
  */
  if (mb_mapping == NULL) 
  {
    fprintf(stderr, "Failed to allocate the mapping: %i %s\n", errno, modbus_strerror(errno));
    modbus_free(ctx);
    return -1;
  }
  
  printf ("waiting for connection!\n") ;
  socket = modbus_tcp_listen(ctx, 1);
  modbus_tcp_accept(ctx, &socket);
  printf ("connected!\n") ;
    return 1;
}

int mb_close(void)
{
  close(socket);
  modbus_mapping_free(mb_mapping);
  modbus_close(ctx);
  modbus_free(ctx);
    return 1;
}

int i2c_eingaenge (void)
{
	int dezzahl2;
	dezzahl2=wiringPiI2CRead (fd2);
	//printf("READ:  %i \n", dezzahl2);
	if (dezzahl2>=128) i2c_in_1[7][1]=1; else i2c_in_1[7][1]=0;
	if (dezzahl2%128>=64) i2c_in_1[6][1]=1; else i2c_in_1[6][1]=0;
	if (dezzahl2%64>=32) i2c_in_1[5][1]=1; else i2c_in_1[5][1]=0;
	if (dezzahl2%32>=16) i2c_in_1[4][1]=1; else i2c_in_1[4][1]=0;		
	if (dezzahl2%16>=8) i2c_in_1[3][1]=1; else i2c_in_1[3][1]=0;			
	if (dezzahl2%8>=4) i2c_in_1[2][1]=1; else i2c_in_1[2][1]=0;			
	if (dezzahl2%4>=2) i2c_in_1[1][1]=1; else i2c_in_1[1][1]=0;
	if (dezzahl2%2>=1) i2c_in_1[0][1]=1; else i2c_in_1[0][1]=0;
	for(i=0;i<=7;i++)	
	{
		mb_mapping->tab_input_bits[(i+32)]=!(i2c_in_1[i][1]);		//High and Low tauschen
	//	printf("EBit %d:%d ",i,i2c_in_1[i][1]);
	}
	//printf ("\n");
  return 1;
}

int i2c_ausgaenge (void)	//
{	
	int i,faktor;
	int dezzahl1=0;//,dezzahl_alt=0;
	for(i=0;i<=7;i++)								//7Output-Ports abfragen je zwei DEZ-Zahlen
	{
		//printf("i2c_Ausgang [%d]: [%d]\n",i,i2c_out_1[i][0]); //J=0 da Adresse ausgegeben werden soll
		if (i==0) faktor=1;
		else if (i==1) faktor=2;
		else if (i==2) faktor=4;
		else if (i==3) faktor=8;
		else if (i==4) faktor=16;
		else if (i==5) faktor=32;
		else if (i==6) faktor=64;
		else if (i==7) faktor=128;
		dezzahl1=dezzahl1+i2c_out_1[i][1]*faktor;
		//printf("Faktor: %d  Dezimalzahl: %d %d\n",faktor, i, dezzahl1);
		//printf("Dezimalzahl1: %d\n", dezzahl1);
	}
	if((e=wiringPiI2CWrite(fd,dezzahl1))<0){
		printf("error writing to slave\n\r");
	}
	return 1;
}

int temp_onewire (char tempsensor[])	//Liest abgespeicherte 1-Wire Werte aus 
{										//hierfr mssen Module "w1-gpio" "w1-therm" 
	char dateiname[60];					//in etc/modules gestartet werden 
	strcpy(dateiname,"/sys/bus/w1/devices/");
	strcat(dateiname,tempsensor);
	strcat(dateiname,"/w1_slave");
	ptr_file = fopen(dateiname, "r");
	if (!ptr_file)
        return 3333;						//bei Fehler unsinnigen Tempwert zurckgeben
	while (fgets(buf,100, ptr_file)!=NULL)
	{};//printf("%s",buf);
	p = strstr(buf, "t=") + 2;
	p[strlen(p)-1] = 0;			//remove new line char
	tempx = atof(p)/100;		//cast to float
	tempx+= 0.5;				//Ziel auf eine Nachkommastelle zu runden 
	temp = (int)tempx; 			//Division durch 10 erfolgt erst in IPS - bertragung als int
	fclose(ptr_file);
	return temp;
}
	

int mb_poll(void)
{
  uint8_t query[MODBUS_TCP_MAX_ADU_LENGTH];
  int rc;
  rc = modbus_receive(ctx, query); 
  if (rc != -1) 
  {
	for(n=40;n<=47;n++)								//Input-Ports abfragen HW von 17-20 ber 32 I2C
	{
		mb_mapping->tab_input_bits[n]=digitalRead(n-7);		//Input-Ports abfragen HW von 17-20 ber 32 I2C
	}
	time_t t;
	t = time(NULL); 
	int min=t%60;
	int sek=t%10;				//durch 10=alle10Sek
	if (sek == 0)   {      		//durch 10=alle10Sek
		for(n=64;n<=65;n++)		//Anzahl Sensoren-jedes Verzeichnis einzeln auslesen	16-da ModbusAdr=16 fr ersten Sensor
		{																				// jeder Sensor 16bit Word in IPS
			switch (n)	{
				case 64:	strcpy(tempsensor,"28-000004aaf379");	//jeweiliger DS18B20 Sensor
						break;
				case 65:	strcpy(tempsensor,"0815");				//jeweiliger DS18B20 Sensor
						break;
				default: break;
			}
			temp=temp_onewire(tempsensor);
			if(temp!=3333) mb_mapping->tab_input_registers[n]=temp;			
		}	

		printf("Temp_hier= %d %d \n",temp,min);	
		//i2c_ausgaenge();
		//i2c_eingaenge();
	} 	
	modbus_reply(ctx, query, rc, mb_mapping);
	i2c_eingaenge();	
	i2c_ausgaenge();
	for(n=0;n<8;n++) digitalWrite(gpio[n], mb_mapping->tab_bits[n]);	//Setzt Ausgnge GPIO auf Basis Modbus
	for(n=16;n<24;n++) i2c_out_1[n-16][1]=mb_mapping->tab_bits[n];		//Setzt Ausgnge der I2C-Karte auf Basis Modbus (liest in Array) 	
	for(n=24;n<32;n++) mb_mapping->tab_bits[n]=i2c_out_1[n-24][1];		//Sendet Rckmeldungen der Ausgnge der I2C-Karte 
  return 1;																//Rckmeldeadresse +8 z.B. IPS-Befehl Bit17 Rckmeldung Bit25
  } 
  else 
  {
    /* Connection closed by the client or error */
    return -1;
  }
}


int poll_loop(void)
{
  for(;;) 
  {
    if(mb_poll()==-1)
    {
      printf("mb error \n");
      mb_close();
      break;
    } 
  }
  printf("quitting loop: %i %s\n", errno, modbus_strerror(errno));
  if(errno == 104) //connection closed by peer
  {
    if(mb_init()) poll_loop();
  }
 return 1;
}

int gpio_init(void)
{
  int n;
  printf ("GPIO Init\n") ;
  if (wiringPiSetup () == -1)
    return 1 ;
  //GPIO2 (PIN3) fr I2C = SDA
  //GPIO3 (PIN5) fr I2C = SCL 
  //GPIO4 (PIN7) fr 1-Wire  
  /*uebrige GPIOs set GPIOs to OUTPUT*/
  for(n=0;n<=7;n++) pinMode(gpio[n], OUTPUT);	//GPIO4=1-Wire in IPS Adressen 0-7 1bit 
  /*set GPIOs to INTPUT*/
  //for(n=1;n<5;n++) pinMode(gpio[n], INPUT);	//GPIO4=1-Wire in IPS Adressen 8-15 1bit nur lesen
  for(n=8;n<=15;n++) pinMode(gpio[n], OUTPUT); //HW-Adressen theoretisch als Input nutzbar 
  printf ("Init Done!\n") ;
  //int wiringPiI2CSetup (int devId) ;
  if((fd=wiringPiI2CSetup(dID))<0){
	printf("error opening i2c channel Ausgabekarte\n\r");
  }
  if((fd2=wiringPiI2CSetup(dID2))<0){
	printf("error opening i2c channel Eingabekarte\n\r");
  }
  if((e=wiringPiI2CWrite(fd,0))<0)		//initial auf Null - wichtig
  {
	printf("error writing to slave\n\r");  
  }		
  // Schleife fuer I2C-Ausgabe Zeilen, Y-Achse
  for(i=0; i<=7; i++) {							//Definition 7 Output-Bits
	// Schleife fuer Spalten, X-Achse
	i2c_out_1[i][0]=i+16;			//ebenfalls Output von 16-23
	i2c_out_1[i][1]=0;	
  }  
  printf("I2C_Out Init Done!\n");
  return 1;
}

int main(void)
{
  gpio_init();
  if(mb_init()) poll_loop();
  return 0;
}
